﻿Type=Class
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	'Globale Variablen notwendig für die Verbindung
	Public IsBtConnected As Boolean
	'Variablen für Speed-Berechnung
	Private speed, tmpSpeed As Float
	Private starttime,timerSpeedElapsed As Long
	Private TempDistance As Float
	Private counter, StepCounter As Int
	Private timerSpeed As Timer
	Private Abrollumfang As Float
	Private time As Long
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	IsBtConnected		= False
	TempDistance		= 0
	speed				= 0
	timerSpeedElapsed	= 0
	counter				= 0
	StepCounter			= 4
	Abrollumfang		= 1.944 'mm

	timerSpeed.Initialize("timerSpeed", 20)
	timerSpeed.Enabled = True
End Sub

Public Sub NewData (KeyCode As String)
		
	Select KeyCode
		Case "+"

			counter = counter + 1
			
			If counter = 1 Then
				'Ab den ersten Abrollumfang wird die Zeit notiert.
				starttime = DateTime.Now
			Else If counter = 2 Then
				time = DateTime.Now - starttime
				tmpSpeed = Abrollumfang / time * 3600
				Log("time=" & time)

				'Km/h
				If tmpSpeed < 15.0 Then
					StepCounter = 3
				Else If tmpSpeed < 25.0 Then
					StepCounter = 4
				Else If tmpSpeed < 50.0 Then
					StepCounter = 7
				Else If tmpSpeed < 75.0 Then
					StepCounter = 10
				Else If tmpSpeed < 100.0 Then
					StepCounter = 14
				Else If tmpSpeed < 125.0 Then
					StepCounter = 18
				Else If tmpSpeed < 150.0 Then
					StepCounter = 22
				Else If tmpSpeed < 175.0 Then
					StepCounter = 26
				Else
					StepCounter = 30
				End If

				Log("StepCounter=" & StepCounter)
				Log(" ")
				
			Else If counter >= StepCounter Then
'				Log("DateTime.Now - starttime=" & (DateTime.Now - starttime))
				TempDistance = counter * Abrollumfang
				speed = TempDistance / (DateTime.Now - starttime) * 3600
				counter = 0
				
			End If
			timerSpeedElapsed = 0
	End Select
End Sub

Public Sub getBTSpeed As Float
	Return speed
End Sub

Sub timerSpeed_Tick
	'Tacho auf null setzten nach 1000 millisec. stillstand.
	timerSpeedElapsed = timerSpeedElapsed + timerSpeed.Interval
	If timerSpeedElapsed > StepCounter * time Then
		Log("speed resetet bei=" & timerSpeedElapsed)
		timerSpeedElapsed = 0
		speed = 0
	End If	
End Sub